/**
 * @author dietlw
 */
package array;

import java.util.HashMap;
import java.util.Map;

class Data {
    final Object o1;
    final Object o2;
    final Object o3;

    Data(Object p1, Object p2, Object p3) {
        o1 = p1; o2 = p2; o3 = p3;
    }

    public boolean equals(Object other) {
        if(!(other instanceof Data)) return false;
        Data mc2 = (Data) other;
        if( mc2.o1 != this.o1 ||
            mc2.o2 != this.o2 ||
            mc2.o3 != this.o3 ) {
            return false;
        } else {
            return true;
        }
    }
}

class DataSingleton {
    static Map<Integer, Data> si;

    static {
        si = new HashMap<Integer, Data>();
    }

    static Data create(int p) {
        if( si.containsKey(p)) {
            return si.get(p);
        } else {
            Data d = new Data(p, p+1, p+2);
            si.put(p, d);
            return d;
        }
    }
}
public class MainConst {

    public static void main(String[] args) {
        final int len = 100000;
        Data[] ar = new Data[len];
        for( int i=0; i<len; ++i) {
            ar[i] = DataSingleton.create(i);
        }
        Data find = ar[99999];

        for( Data d : ar) {
            if( d.equals(find) ) {
                System.out.println("Found!");
            }
        }
    }
}
