/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Client;

import java.rmi.RemoteException;
import java.rmi.NotBoundException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import Server.IServerInterface;


interface ClientListener{
    void messageRecived(String message);
}

public class ClientImpl extends UnicastRemoteObject implements IClientInterface{

    private IServerInterface server;
    private ClientListener listener;

    public ClientImpl() throws RemoteException {}

    ClientImpl(ClientListener listener) throws RemoteException{
        this.listener = listener;
    }

    public void receiveMessage(String str) throws RemoteException{
        listener.messageRecived(str);
    }

    static ClientImpl createClinet(ClientListener listener){
        try {
           ClientImpl client = new ClientImpl(listener);
           client.connect();
           return client;
        } catch (RemoteException ex) {
            //Error handling
            return null;
        }
    }

    private void connect(){
        try {
            Registry rmi = LocateRegistry.getRegistry(IServerInterface.PORT);
            server = (IServerInterface) rmi.lookup(IServerInterface.LOOKUP_NAME);
            server.register(this);
        } catch (NotBoundException ex) {
            //Error handling
        } catch (RemoteException ex) {
            //Error handling
        }
    }

    public void sendMessage(String message){
        try {
            server.sendMessage(this, message);
        } catch( Exception e ) {
            //Error handling
        }
    }
}
