/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ClientRunner;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.util.zip.ZipFile;


import Shared.DownloadBlock;
import Shared.IDownloadSession;
import Shared.ISimpleServer;
import Shared.CheckSum;
import Shared.Zipper;


/**
 *
 * @author rudicha
 */
public class ClientRunner {

	private static final String CHECK_SUM_ERROR = "Invalid checksum";	
	private static final String JAVA_EXEC = "java";
	private static final String CLASSPATH_TAG = "-cp";
	private static final String RUN_CLASS = "Client.ClientForm";
	private static final String BINARY_FOLDER = "build" + File.separator +
            "classes" + File.separator;
	private static final String CODE_ZIP = "client.zip";
	private static final String CLASSPATH = "downloaded"+File.separator;

	private static void downloadBinaries(ISimpleServer server) throws RemoteException, IOException {
		IDownloadSession session = server.initializeBinaryDownload();

		long checkSum = session.getCheckSum();
		DownloadBlock block;
		FileOutputStream fOut = new FileOutputStream(CODE_ZIP);

		do{
			block = session.getCurrentBlock();
			fOut.write(block.getData());
		}while(!block.isLast());
		fOut.close();

		ZipFile zipFile = new ZipFile(CODE_ZIP);
		Zipper zipper = new Zipper();
		if(CheckSum.getCRC32(CODE_ZIP) != checkSum)
			throw new IOException(CHECK_SUM_ERROR);

		zipper.uncompress(zipFile, CLASSPATH);
	}

	private static void start(){
		ProcessBuilder builder = new ProcessBuilder(JAVA_EXEC,CLASSPATH_TAG, CLASSPATH+BINARY_FOLDER,RUN_CLASS);
		Process p = null;
        try {
            p = builder.start();
            p.waitFor();
		} catch (IOException e) {
            e.printStackTrace();
		} catch (InterruptedException e) {
            e.printStackTrace();
        }

	}


    public static void main(String[] args) {
        try {
            Registry rmi = LocateRegistry.getRegistry(ISimpleServer.PORT);
            ISimpleServer server = (ISimpleServer) rmi.lookup(ISimpleServer.LOOKUP_NAME);
            downloadBinaries(server);
            start();
        } catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("Error");
        }
    }
}
