/*
 * CREDITS: this example is based on material developed for the
 * Introduction to Programming course by Nimi Berman and Cay Horstmann
 * at San Jose State University, CA.
 * 
 * The original material can be found at:
 *    www.cs.sjsu.edu/faculty/horstman/CS46A/debugger/tutorial.html
 */

package wordanalyzer;

import junit.framework.TestCase;

public class WordAnalyzerTest extends TestCase {

   public static void testFirstRepeatedCharacter() {
      wa.setWord("aardvark"); // expect: a
      assertTrue(wa.firstRepeatedCharacter() == 'a');
            
      wa.setWord("roommate"); // expect: o (not m)
      assertTrue(wa.firstRepeatedCharacter() == 'o');
      
      wa.setWord("mate"); // expect: 0 (no duplicate letters)
      assertTrue(wa.firstRepeatedCharacter() == 0);  

      wa.setWord("test"); // expect: 0 (the t isn't repeating)
      assertTrue(wa.firstRepeatedCharacter() == 0);
   }

   public static void testFirstMultipleCharacter() {      
      wa.setWord("missisippi"); // expect: i (not m or s)
      assertTrue(wa.firstMultipleCharacter() == 'i');
            
      wa.setWord("mate"); // expect: 0
      assertTrue(wa.firstMultipleCharacter() == 0);
      
      wa.setWord("test"); // expect: t
      assertTrue(wa.firstMultipleCharacter() == 't');
   }

   public static void testCountRepeatedCharacters() {
       wa.setWord("mississippiii"); // expect: 4 (ss, ss, pp, iii)
       assertTrue(wa.countRepeatedCharacters() == 4);
       
       wa.setWord("test"); // expect: 0 (no repeated letters)
       assertTrue(wa.countRepeatedCharacters() == 0);
       
       wa.setWord("aabbcdaaaabb"); // expect: 4 (aa, bb, aaaa, bb)
       assertTrue(wa.countRepeatedCharacters() == 4);
   }

   private static WordAnalyzer wa = new WordAnalyzer();
}
